import{s as Di,f as Ki,n as Gi,o as Fi}from"../chunks/scheduler.7bc62968.js";import{S as Ji,i as Oi,g as n,s as l,r as h,A as Yi,h as r,f as i,c as a,j as Et,u as m,x as s,k as $e,y as Zi,a as o,v as u,d as f,t as p,w as c}from"../chunks/index.66556066.js";import{H as d}from"../chunks/Heading.3f0870db.js";function Qi(Dt){let v,Pe,ke,Se,w,Ae,y,Kt="Dear learner,",Ue,b,Gt="Welcome to the community-driven course on computer vision. Computer vision is revolutionizing our world in many ways, from unlocking phones with facial recognition to analyzing medical images for disease detection, enhancing public safety through surveillance systems, monitoring wildlife, and creating new images. Together, we’ll dive into the fascinating world of computer vision!",ze,C,Ft="Throughout this course, we’ll cover everything from the basics to the latest advancements in computer vision. It’s structured to include various foundational topics, making it friendly and accessible for everyone. We’re delighted to have you join us for this exciting journey!",Re,x,Jt="In this page, you can find how to join the learners community, making a submission and getting a certificate, and more details about the course!",We,T,Ie,M,Ot="To obtain your certification for completing the course, complete the following assignments:",Ve,L,Yt="<li>Training/fine-tuning a Model</li> <li>Building an application and hosting it on 🤗 Spaces</li>",qe,H,je,$,Zt="There are notebooks under the Notebooks/Vision Transformers section. As of now, we have notebooks for object detection, image segmentation, and image classification. You can either train a model on a dataset that exists on 🤗 Hub or upload a dataset to a dataset repository and train a model on that.",Be,k,Qt="The model repository needs to have the following:",Ne,_,Xt='<li>A properly filled Model Card <a href="https://huggingface.co/docs/hub/en/model-cards" rel="nofollow">you can check out here for more information</a></li> <li>If you trained a model with transformers and pushed it to Hub, the model card will be generated. In that case, edit the card and fill in more details.</li> <li>Add the dataset’s ID to the model card to link the model repository to the dataset repository.</li>',Ee,P,De,S,ei="In this assignment section, you’ll be building a Gradio-based application for your computer vision model and sharing it on 🤗 Spaces. Learn more about these tasks using the following resources:",Ke,A,ti='<li><a href="https://huggingface.co/learn/nlp-course/chapter9/1?fw=pt#introduction-to-gradio" rel="nofollow">Getting started with Gradio</a></li> <li><a href="https://huggingface.co/learn/nlp-course/chapter9/4?fw=pt" rel="nofollow">How to share your application on 🤗 Spaces</a></li>',Ge,U,Fe,z,ii='Once you’ve finished the assignments — Training/fine-tuning a Model and Creating a Space — please complete the <a href="https://forms.gle/JaSYEf1pEZ4HtNKGA" rel="nofollow">form</a> with your name, email, and links to your model and Space repositories to receive your certificate',Je,R,Oe,W,oi='We invite you to be a part of <a href="http://hf.co/join/discord" rel="nofollow">our active and supportive Discord community</a>, where engaging conversations and shared interests flourish every day and where this course started. You will find peers with whom you can exchange ideas and resources. It is your source to collaborate, get feedback, and ask questions!',Ye,I,li="It is also a good way to motivate yourself to follow the course. Joining our community is an excellent way to stay engaged. Who knows what is the next thing we will build together?",Ze,V,ai="As AI continues to advance, so does the quality of our discussions and the diversity of perspectives within our community. Upon becoming a member, you’ll have an opportunity to connect with fellow course participants, exchange ideas, and collaborate with others. Moreover, the contributors to this course are active on Discord and might help you when needed. Join us now!",Qe,q,Xe,j,ni="There are many channels focused on various topics on our Discord server. You will find people discussing papers, organizing events, sharing their projects and ideas, brainstorming, and so much more.",et,B,ri="As a computer vision course learner, you may find the following set of channels particularly relevant:",tt,N,si="<li><code>#computer-vision</code>: a catch-all channel for everything related to computer vision.</li> <li><code>#cv-study-group</code>: a place to exchange ideas, ask questions about specific posts and start discussions.</li> <li><code>#3d</code>: a channel to discuss aspects of computer vision specific to 3D computer vision</li>",it,E,hi="If you are interested in generative AI, we also invite you to join all channels related to the Diffusion Models: #core-announcements, #discussions, #dev-discussions, and #diff-i-made-this.",ot,D,lt,K,mi="The course is composed of theory, practical tutorials, and engaging challenges.",at,G,ui="<li><strong>Theory Part</strong> : This section covers the theoretical principles of computer vision, explained in detail with practical examples.</li> <li><strong>Hands-on Tutorials</strong> : You will learn how to train and apply key computer vision models using Google Colab notebooks.</li>",nt,F,fi='To illustrate what these computer vision models can achieve, here is a simple demo of a cat vs. dog classifier created with <a href="https://www.gradio.app/" rel="nofollow">Gradio</a>.',rt,g,pi,st,J,ci="Throughout this course, we will cover everything from the basics to the latest advancements in computer vision. It is structured to include various foundational topics, giving you a comprehensive understanding of what makes computer vision so impactful today.",ht,O,mt,Y,di='Before beginning this course, make sure that you have some experience with Python programming and are familiar with transformers, machine learning, and neural networks. If these are new to you, consider reviewing the <a href="https://huggingface.co/learn/nlp-course/chapter1/3?fw=pt" rel="nofollow">first unit of the Hugging Face NLP course</a>. While a strong knowledge of pre-processing techniques and mathematical operations like convolutions is beneficial, they are not prerequisites.',ut,Z,ft,Q,gi="The course is organized into multiple units, covering the fundamentals and delving into an in-depth exploration of state-of-the-art models.",pt,X,vi="<li><strong>Unit 1 - Fundamentals of Computer Vision</strong> : this unit covers the essential concepts to get started with computer vision: the need for computer vision, the field’s basics, and its applications. Explore image fundamentals, formation, and preprocessing, along with key aspects of feature extraction.</li> <li><strong>Unit 2 - Convolutional Neural Networks (CNNs)</strong> : delve into the world of CNNs, understanding their general architecture, key concepts, and common pre-trained models. Learn how to apply transfer learning and fine-tuning to adapt CNNs for various tasks.</li> <li><strong>Unit 3 - Vision Transformers</strong> : explore transformer architecture in the context of computer vision and learn how they compare to CNNs. Understand common vision transformers such as Swin, DETR, and CVT, along with techniques for transfer learning and fine-tuning.</li> <li><strong>Unit 4 - Multimodal Models</strong> : understand the fusion of text and vision by exploring multimodal tasks like image-to-text and text-to-image. Study models such as CLIP and its relatives (GroupViT, BLIPM, Owl-VIT), and master transfer learning techniques for multimodal tasks.</li> <li><strong>Unit 5 - Generative Models</strong> : explore generative models, including GANs, VAEs, and diffusion models. Learn about their differences and applications in tasks such as text-to-image, image-to-image, and inpainting.</li> <li><strong>Unit 6 - Basic Computer Vision Tasks</strong> : cover fundamental tasks like image classification, object detection, and segmentation and the models used in them (YOLO, SAM). Gain insights into metrics and practical applications for these tasks.</li> <li><strong>Unit 7 - Video and Video Processing</strong> : examine the characteristics of videos, the role of video processing, and the challenges compared to image processing. Explore temporal continuity, motion estimation, and practical applications in video processing.</li> <li><strong>Unit 8 - 3D Vision, Scene Rendering, and Reconstruction</strong> : delve into the complexities of three-dimensional vision, exploring concepts like Nerf and GQN for scene rendering and reconstruction. Understand the challenges and applications of 3D vision in computer vision, and how it provides an even more comprehensive view of spatial information.</li> <li><strong>Unit 9 - Model Optimization</strong> : explore the critical aspects of model optimization. Cover techniques such as model compression, deployment considerations, and the usage of tools and frameworks. Include topics topics like distillation, pruning, and TinyML for efficient model deployment.</li> <li><strong>Unit 10 - Synthetic Data Creation</strong> : discover the importance of synthetic data creation using deep generative models. Explore methods like point clouds and diffusion models and investigate major synthetic datasets and their applications in computer vision.</li> <li><strong>Unit 11 - Zero Shot Computer Vision</strong> : delve into the realm of zero-shot learning in computer vision, covering aspects of generalization, transfer learning, and its applications in tasks such as zero-shot recognition and image segmentation. Explore the relationship between zero-shot learning and transfer learning across various computer vision domains.</li> <li><strong>Unit 12 - Ethics and Biases in Audio and Computer Vision</strong> : understand the ethical considerations specific to computer vision. Explore why ethics matter, how biases can infiltrate AI models, and the types of biases prevalent in these domains. Learn how to do bias evaluation and mitigation strategies, emphasizing responsible development and deployment of AI technologies.</li> <li><strong>Unit 13 - Outlook and Emerging Trends</strong> : explore current trends and emerging architectures . Delve into innovative approaches like Retentive Network, Hiera, Hyena, I-JEPA, and Retention Vision Models.</li>",ct,ee,dt,te,wi="This is made by the Hugging Face Community with love! Our goal was to create a computer vision course that is beginner-friendly and that could act as a resource for others. Around 60+ people from all over the world joined forces to make this project happen. Here we give them credit:",gt,ie,yi="<strong>Unit 1 - Fundamentals of Computer Vision</strong>",vt,oe,bi='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a></li> <li>Writers: <a href="https://github.com/seshu-pavan" rel="nofollow">Seshu Pavan Mutyala</a>, <a href="https://github.com/bellabf" rel="nofollow">Isabella Bicalho-Frazeto</a>, <a href="https://github.com/aman06012003" rel="nofollow">Aman Kapoor</a>, <a href="https://github.com/froestiago" rel="nofollow">Tiago Comassetto Fróes</a>, <a href="https://github.com/adityaiiitr" rel="nofollow">Aditya Mishra</a>, <a href="https://github.com/krmdel" rel="nofollow">Kerem Delikoyun</a>, <a href="https://github.com/klyap" rel="nofollow">Ker Lee Yap</a>, <a href="https://github.com/kfahn22" rel="nofollow">Kathy Fahnline</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a></li>',wt,le,Ci="<strong>Unit 2 - Convolutional Neural Networks (CNNs)</strong>",yt,ae,xi='<li>Reviewers: <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/sezan92" rel="nofollow">Sezan</a>, <a href="https://github.com/JvThunder" rel="nofollow">Joshua Adrian Cahyono</a>, <a href="https://github.com/themurtazanazir" rel="nofollow">Murtaza Nazir</a>, <a href="https://github.com/albertkao227" rel="nofollow">Albert Kao</a>, <a href="https://github.com/sitamgithub-MSIT" rel="nofollow">Sitam Meur</a></li> <li>Writers: <a href="https://github.com/emre570" rel="nofollow">Emre Albayrak</a>, <a href="https://github.com/ShamieCC" rel="nofollow">Caroline Shamiso Chitongo</a>, <a href="https://github.com/sezan92" rel="nofollow">Sezan</a>, <a href="https://github.com/JvThunder" rel="nofollow">Joshua Adrian Cahyono</a>, <a href="https://github.com/themurtazanazir" rel="nofollow">Murtaza Nazir</a>, <a href="https://github.com/albertkao227" rel="nofollow">Albert Kao</a>, <a href="https://github.com/bellabf" rel="nofollow">Isabella Bicalho-Frazeto</a>, <a href="https://github.com/aman06012003" rel="nofollow">Aman Kapoor</a>, <a href="https://github.com/sitamgithub-MSIT" rel="nofollow">Sitam Meur</a></li>',bt,ne,Ti="<strong>Unit 3 - Vision Transformers</strong>",Ct,re,Mi='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>, <a href="https://github.com/sezan92" rel="nofollow">Sezan</a></li> <li>Writers: <a href="https://github.com/SuryaKrishna02" rel="nofollow">Surya Guthikonda</a>, <a href="https://github.com/klyap" rel="nofollow">Ker Lee Yap</a>, <a href="https://bento.me/anindyadeep" rel="nofollow">Anindyadeep Sannigrahi</a>, <a href="https://github.com/hanouticelina" rel="nofollow">Celina Hanouti</a>, <a href="https://github.com/Mkrolick" rel="nofollow">Malcolm Krolick</a></li>',xt,se,Li="<strong>Unit 4 - Multimodal Models</strong>",Tt,he,Hi='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/snehilsanyal" rel="nofollow">Snehil Sanyal</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/charchit7" rel="nofollow">Charchit Sharma</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>, <a href="https://github.com/bellabf" rel="nofollow">Isabella Bicalho-Frazeto</a></li> <li>Writers: <a href="https://github.com/snehilsanyal" rel="nofollow">Snehil Sanyal</a>, <a href="https://github.com/SuryaKrishna02" rel="nofollow">Surya Guthikonda</a>, <a href="https://github.com/mattmdjaga" rel="nofollow">Mateusz Dziemian</a>, <a href="https://github.com/charchit7" rel="nofollow">Charchit Sharma</a>, <a href="https://github.com/minemile" rel="nofollow">Evstifeev Stepan</a>, <a href="https://github.com/jeremy-k3/" rel="nofollow">Jeremy Kespite</a>, <a href="https://github.com/bellabf" rel="nofollow">Isabella Bicalho-Frazeto</a></li>',Mt,me,$i="<strong>Unit 5 - Generative Models</strong>",Lt,ue,ki='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/WilliamBonvini" rel="nofollow">William Bonvini</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>-</li> <li>Writers: <a href="github.com/jere357">Jeronim Matijević</a>, <a href="https://github.com/mattmdjaga" rel="nofollow">Mateusz Dziemian</a>, <a href="https://github.com/charchit7" rel="nofollow">Charchit Sharma</a></li>',Ht,fe,_i="<strong>Unit 6 - Basic Computer Vision Tasks</strong>",$t,pe,Pi='<li>Reviewers: <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a></li> <li>Writers: <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a></li>',kt,ce,Si="<strong>Unit 7 - Video and Video Processing</strong>",_t,de,Ai='<li>Reviewers: <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a></li> <li>Writers: <a href="https://github.com/DiwakarBasnet" rel="nofollow">Diwakar Basnet</a></li>',Pt,ge,Ui="<strong>Unit 8 - 3D Vision, Scene Rendering, and Reconstruction</strong>",St,ve,zi='<li><p>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/WilliamBonvini" rel="nofollow">William Bonvini</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a>, <a href="https://github.com/atayloraerospace0" rel="nofollow">Ameed Taylor</a></p></li> <li><p>Writers: <a href="https://github.com/jfozard" rel="nofollow">John Fozard</a>, <a href="https://github.com/vasugupta9" rel="nofollow">Vasu Gupta</a></p> <p><strong>Unit 9 - Model Optimization</strong></p></li> <li><p>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a></p></li> <li><p>Writer: <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a></p></li>',At,we,Ri="<strong>Unit 10 - Synthetic Data Creation</strong>",Ut,ye,Wi='<li>Reviewers: <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>, <a href="https://github.com/Zekrom-7780" rel="nofollow">Bhavesh Misra</a></li> <li>Writers: <a href="https://github.com/WilliamBonvini" rel="nofollow">William Bonvini</a>, <a href="https://github.com/alperiox" rel="nofollow">Alper Balbay</a>, <a href="https://github.com/miniMaddy" rel="nofollow">Madhav Kumar</a>, <a href="https://github.com/Zekrom-7780" rel="nofollow">Bhavesh Misra</a>, <a href="https://github.com/kfahn22" rel="nofollow">Kathy Fahnline</a></li>',zt,be,Ii="<strong>Unit 11 - Zero Shot Computer Vision</strong>",Rt,Ce,Vi='<li>Reviewers: <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/albertkao227" rel="nofollow">Albert Kao</a></li> <li>Writers: <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/albertkao227" rel="nofollow">Albert Kao</a></li>',Wt,xe,qi="<strong>Unit 12 - Ethics and Biases in Audio and Computer Vision</strong>",It,Te,ji='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/charchit7" rel="nofollow">Charchit Sharma</a>, <a href="https://github.com/adhiiisetiawan" rel="nofollow">Adhi Setiawan</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>, <a href="https://github.com/Zekrom-7780" rel="nofollow">Bhavesh Misra</a></li> <li>Writers: <a href="https://github.com/snehilsanyal" rel="nofollow">Snehil Sanyal</a>, <a href="https://github.com/Zekrom-7780" rel="nofollow">Bhavesh Misra</a></li>',Vt,Me,Bi="<strong>Unit 13 - Outlook and Emerging Trends</strong>",qt,Le,Ni='<li>Reviewers: <a href="https://github.com/ratan" rel="nofollow">Ratan Prasad</a>, <a href="https://github.com/atayloraerospace" rel="nofollow">Ameed Taylor</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a></li> <li>Writers: <a href="https://github.com/farrosalferro" rel="nofollow">Farros Alferro</a>, <a href="https://github.com/mmhamdy" rel="nofollow">Mohammed Hamdy</a>, <a href="https://github.com/lulmer" rel="nofollow">Louis Ulmer</a>, <a href="https://github.com/dariowsz" rel="nofollow">Dario Wisznewer</a>, <a href="https://github.com/gonzachiar" rel="nofollow">gonzachiar</a></li>',jt,He,Ei="We are happy to have you here, let’s get started!",Bt,_e,Nt;return w=new d({props:{title:"Welcome to the Community Computer Vision Course",local:"welcome-to-the-community-computer-vision-course",headingTag:"h1"}}),T=new d({props:{title:"Assignment 📄",local:"assignment-",headingTag:"h2"}}),H=new d({props:{title:"Training/fine-tuning a Model",local:"trainingfine-tuning-a-model",headingTag:"h3"}}),P=new d({props:{title:"Creating a Space",local:"creating-a-space",headingTag:"h3"}}),U=new d({props:{title:"Certification 🥇",local:"certification-",headingTag:"h2"}}),R=new d({props:{title:"Join the community!",local:"join-the-community",headingTag:"h2"}}),q=new d({props:{title:"Computer Vision Channels",local:"computer-vision-channels",headingTag:"h2"}}),D=new d({props:{title:"What you will learn",local:"what-you-will-learn",headingTag:"h2"}}),O=new d({props:{title:"Pre-requisites",local:"pre-requisites",headingTag:"h2"}}),Z=new d({props:{title:"Course Structure",local:"course-structure",headingTag:"h2"}}),ee=new d({props:{title:"Meet our team",local:"meet-our-team",headingTag:"h2"}}),{c(){v=n("meta"),Pe=l(),ke=n("p"),Se=l(),h(w.$$.fragment),Ae=l(),y=n("p"),y.textContent=Kt,Ue=l(),b=n("p"),b.textContent=Gt,ze=l(),C=n("p"),C.textContent=Ft,Re=l(),x=n("p"),x.textContent=Jt,We=l(),h(T.$$.fragment),Ie=l(),M=n("p"),M.textContent=Ot,Ve=l(),L=n("ol"),L.innerHTML=Yt,qe=l(),h(H.$$.fragment),je=l(),$=n("p"),$.textContent=Zt,Be=l(),k=n("p"),k.textContent=Qt,Ne=l(),_=n("ol"),_.innerHTML=Xt,Ee=l(),h(P.$$.fragment),De=l(),S=n("p"),S.textContent=ei,Ke=l(),A=n("ul"),A.innerHTML=ti,Ge=l(),h(U.$$.fragment),Fe=l(),z=n("p"),z.innerHTML=ii,Je=l(),h(R.$$.fragment),Oe=l(),W=n("p"),W.innerHTML=oi,Ye=l(),I=n("p"),I.textContent=li,Ze=l(),V=n("p"),V.textContent=ai,Qe=l(),h(q.$$.fragment),Xe=l(),j=n("p"),j.textContent=ni,et=l(),B=n("p"),B.textContent=ri,tt=l(),N=n("ul"),N.innerHTML=si,it=l(),E=n("p"),E.textContent=hi,ot=l(),h(D.$$.fragment),lt=l(),K=n("p"),K.textContent=mi,at=l(),G=n("ul"),G.innerHTML=ui,nt=l(),F=n("p"),F.innerHTML=fi,rt=l(),g=n("iframe"),st=l(),J=n("p"),J.textContent=ci,ht=l(),h(O.$$.fragment),mt=l(),Y=n("p"),Y.innerHTML=di,ut=l(),h(Z.$$.fragment),ft=l(),Q=n("p"),Q.textContent=gi,pt=l(),X=n("ul"),X.innerHTML=vi,ct=l(),h(ee.$$.fragment),dt=l(),te=n("p"),te.textContent=wi,gt=l(),ie=n("p"),ie.innerHTML=yi,vt=l(),oe=n("ul"),oe.innerHTML=bi,wt=l(),le=n("p"),le.innerHTML=Ci,yt=l(),ae=n("ul"),ae.innerHTML=xi,bt=l(),ne=n("p"),ne.innerHTML=Ti,Ct=l(),re=n("ul"),re.innerHTML=Mi,xt=l(),se=n("p"),se.innerHTML=Li,Tt=l(),he=n("ul"),he.innerHTML=Hi,Mt=l(),me=n("p"),me.innerHTML=$i,Lt=l(),ue=n("ul"),ue.innerHTML=ki,Ht=l(),fe=n("p"),fe.innerHTML=_i,$t=l(),pe=n("ul"),pe.innerHTML=Pi,kt=l(),ce=n("p"),ce.innerHTML=Si,_t=l(),de=n("ul"),de.innerHTML=Ai,Pt=l(),ge=n("p"),ge.innerHTML=Ui,St=l(),ve=n("ul"),ve.innerHTML=zi,At=l(),we=n("p"),we.innerHTML=Ri,Ut=l(),ye=n("ul"),ye.innerHTML=Wi,zt=l(),be=n("p"),be.innerHTML=Ii,Rt=l(),Ce=n("ul"),Ce.innerHTML=Vi,Wt=l(),xe=n("p"),xe.innerHTML=qi,It=l(),Te=n("ul"),Te.innerHTML=ji,Vt=l(),Me=n("p"),Me.innerHTML=Bi,qt=l(),Le=n("ul"),Le.innerHTML=Ni,jt=l(),He=n("p"),He.textContent=Ei,Bt=l(),_e=n("p"),this.h()},l(e){const t=Yi("svelte-u9bgzb",document.head);v=r(t,"META",{name:!0,content:!0}),t.forEach(i),Pe=a(e),ke=r(e,"P",{}),Et(ke).forEach(i),Se=a(e),m(w.$$.fragment,e),Ae=a(e),y=r(e,"P",{"data-svelte-h":!0}),s(y)!=="svelte-5uvv1z"&&(y.textContent=Kt),Ue=a(e),b=r(e,"P",{"data-svelte-h":!0}),s(b)!=="svelte-nn7wg9"&&(b.textContent=Gt),ze=a(e),C=r(e,"P",{"data-svelte-h":!0}),s(C)!=="svelte-104v4vu"&&(C.textContent=Ft),Re=a(e),x=r(e,"P",{"data-svelte-h":!0}),s(x)!=="svelte-mecmy2"&&(x.textContent=Jt),We=a(e),m(T.$$.fragment,e),Ie=a(e),M=r(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-akc34d"&&(M.textContent=Ot),Ve=a(e),L=r(e,"OL",{"data-svelte-h":!0}),s(L)!=="svelte-1kq1j1j"&&(L.innerHTML=Yt),qe=a(e),m(H.$$.fragment,e),je=a(e),$=r(e,"P",{"data-svelte-h":!0}),s($)!=="svelte-1230z5s"&&($.textContent=Zt),Be=a(e),k=r(e,"P",{"data-svelte-h":!0}),s(k)!=="svelte-1liohb8"&&(k.textContent=Qt),Ne=a(e),_=r(e,"OL",{"data-svelte-h":!0}),s(_)!=="svelte-g1xkud"&&(_.innerHTML=Xt),Ee=a(e),m(P.$$.fragment,e),De=a(e),S=r(e,"P",{"data-svelte-h":!0}),s(S)!=="svelte-bv4qs0"&&(S.textContent=ei),Ke=a(e),A=r(e,"UL",{"data-svelte-h":!0}),s(A)!=="svelte-11187cy"&&(A.innerHTML=ti),Ge=a(e),m(U.$$.fragment,e),Fe=a(e),z=r(e,"P",{"data-svelte-h":!0}),s(z)!=="svelte-1371upg"&&(z.innerHTML=ii),Je=a(e),m(R.$$.fragment,e),Oe=a(e),W=r(e,"P",{"data-svelte-h":!0}),s(W)!=="svelte-s4dezh"&&(W.innerHTML=oi),Ye=a(e),I=r(e,"P",{"data-svelte-h":!0}),s(I)!=="svelte-1xmulcb"&&(I.textContent=li),Ze=a(e),V=r(e,"P",{"data-svelte-h":!0}),s(V)!=="svelte-ylc3yd"&&(V.textContent=ai),Qe=a(e),m(q.$$.fragment,e),Xe=a(e),j=r(e,"P",{"data-svelte-h":!0}),s(j)!=="svelte-vmt9w"&&(j.textContent=ni),et=a(e),B=r(e,"P",{"data-svelte-h":!0}),s(B)!=="svelte-1hzfeed"&&(B.textContent=ri),tt=a(e),N=r(e,"UL",{"data-svelte-h":!0}),s(N)!=="svelte-1fbxg3o"&&(N.innerHTML=si),it=a(e),E=r(e,"P",{"data-svelte-h":!0}),s(E)!=="svelte-1rdo52w"&&(E.textContent=hi),ot=a(e),m(D.$$.fragment,e),lt=a(e),K=r(e,"P",{"data-svelte-h":!0}),s(K)!=="svelte-12rcyrl"&&(K.textContent=mi),at=a(e),G=r(e,"UL",{"data-svelte-h":!0}),s(G)!=="svelte-1df0mcf"&&(G.innerHTML=ui),nt=a(e),F=r(e,"P",{"data-svelte-h":!0}),s(F)!=="svelte-iydyvi"&&(F.innerHTML=fi),rt=a(e),g=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),Et(g).forEach(i),st=a(e),J=r(e,"P",{"data-svelte-h":!0}),s(J)!=="svelte-1afyxwp"&&(J.textContent=ci),ht=a(e),m(O.$$.fragment,e),mt=a(e),Y=r(e,"P",{"data-svelte-h":!0}),s(Y)!=="svelte-1959nwf"&&(Y.innerHTML=di),ut=a(e),m(Z.$$.fragment,e),ft=a(e),Q=r(e,"P",{"data-svelte-h":!0}),s(Q)!=="svelte-ukgt5n"&&(Q.textContent=gi),pt=a(e),X=r(e,"UL",{"data-svelte-h":!0}),s(X)!=="svelte-1ofbfbv"&&(X.innerHTML=vi),ct=a(e),m(ee.$$.fragment,e),dt=a(e),te=r(e,"P",{"data-svelte-h":!0}),s(te)!=="svelte-u2ix6e"&&(te.textContent=wi),gt=a(e),ie=r(e,"P",{"data-svelte-h":!0}),s(ie)!=="svelte-161wptx"&&(ie.innerHTML=yi),vt=a(e),oe=r(e,"UL",{"data-svelte-h":!0}),s(oe)!=="svelte-run03c"&&(oe.innerHTML=bi),wt=a(e),le=r(e,"P",{"data-svelte-h":!0}),s(le)!=="svelte-17oydyy"&&(le.innerHTML=Ci),yt=a(e),ae=r(e,"UL",{"data-svelte-h":!0}),s(ae)!=="svelte-1c4qdm"&&(ae.innerHTML=xi),bt=a(e),ne=r(e,"P",{"data-svelte-h":!0}),s(ne)!=="svelte-fpds7l"&&(ne.innerHTML=Ti),Ct=a(e),re=r(e,"UL",{"data-svelte-h":!0}),s(re)!=="svelte-egqyb8"&&(re.innerHTML=Mi),xt=a(e),se=r(e,"P",{"data-svelte-h":!0}),s(se)!=="svelte-1cyhqbe"&&(se.innerHTML=Li),Tt=a(e),he=r(e,"UL",{"data-svelte-h":!0}),s(he)!=="svelte-4v5dh5"&&(he.innerHTML=Hi),Mt=a(e),me=r(e,"P",{"data-svelte-h":!0}),s(me)!=="svelte-17r6uwb"&&(me.innerHTML=$i),Lt=a(e),ue=r(e,"UL",{"data-svelte-h":!0}),s(ue)!=="svelte-1xk9ov0"&&(ue.innerHTML=ki),Ht=a(e),fe=r(e,"P",{"data-svelte-h":!0}),s(fe)!=="svelte-1rgsq49"&&(fe.innerHTML=_i),$t=a(e),pe=r(e,"UL",{"data-svelte-h":!0}),s(pe)!=="svelte-tax7s"&&(pe.innerHTML=Pi),kt=a(e),ce=r(e,"P",{"data-svelte-h":!0}),s(ce)!=="svelte-os5hud"&&(ce.innerHTML=Si),_t=a(e),de=r(e,"UL",{"data-svelte-h":!0}),s(de)!=="svelte-1mmobdm"&&(de.innerHTML=Ai),Pt=a(e),ge=r(e,"P",{"data-svelte-h":!0}),s(ge)!=="svelte-gim8ka"&&(ge.innerHTML=Ui),St=a(e),ve=r(e,"UL",{"data-svelte-h":!0}),s(ve)!=="svelte-1mia5qf"&&(ve.innerHTML=zi),At=a(e),we=r(e,"P",{"data-svelte-h":!0}),s(we)!=="svelte-eq5a0z"&&(we.innerHTML=Ri),Ut=a(e),ye=r(e,"UL",{"data-svelte-h":!0}),s(ye)!=="svelte-w0kut6"&&(ye.innerHTML=Wi),zt=a(e),be=r(e,"P",{"data-svelte-h":!0}),s(be)!=="svelte-1wq1k33"&&(be.innerHTML=Ii),Rt=a(e),Ce=r(e,"UL",{"data-svelte-h":!0}),s(Ce)!=="svelte-11jn5u4"&&(Ce.innerHTML=Vi),Wt=a(e),xe=r(e,"P",{"data-svelte-h":!0}),s(xe)!=="svelte-4alqqo"&&(xe.innerHTML=qi),It=a(e),Te=r(e,"UL",{"data-svelte-h":!0}),s(Te)!=="svelte-9uj99m"&&(Te.innerHTML=ji),Vt=a(e),Me=r(e,"P",{"data-svelte-h":!0}),s(Me)!=="svelte-1i26xgs"&&(Me.innerHTML=Bi),qt=a(e),Le=r(e,"UL",{"data-svelte-h":!0}),s(Le)!=="svelte-kvg0ab"&&(Le.innerHTML=Ni),jt=a(e),He=r(e,"P",{"data-svelte-h":!0}),s(He)!=="svelte-xvo1bn"&&(He.textContent=Ei),Bt=a(e),_e=r(e,"P",{}),Et(_e).forEach(i),this.h()},h(){$e(v,"name","hf:doc:metadata"),$e(v,"content",Xi),Ki(g.src,pi="https://huggingface.co/spaces/ak0601/cat_dog_classifier")||$e(g,"src",pi),$e(g,"frameborder","0"),$e(g,"width","850"),$e(g,"height","450")},m(e,t){Zi(document.head,v),o(e,Pe,t),o(e,ke,t),o(e,Se,t),u(w,e,t),o(e,Ae,t),o(e,y,t),o(e,Ue,t),o(e,b,t),o(e,ze,t),o(e,C,t),o(e,Re,t),o(e,x,t),o(e,We,t),u(T,e,t),o(e,Ie,t),o(e,M,t),o(e,Ve,t),o(e,L,t),o(e,qe,t),u(H,e,t),o(e,je,t),o(e,$,t),o(e,Be,t),o(e,k,t),o(e,Ne,t),o(e,_,t),o(e,Ee,t),u(P,e,t),o(e,De,t),o(e,S,t),o(e,Ke,t),o(e,A,t),o(e,Ge,t),u(U,e,t),o(e,Fe,t),o(e,z,t),o(e,Je,t),u(R,e,t),o(e,Oe,t),o(e,W,t),o(e,Ye,t),o(e,I,t),o(e,Ze,t),o(e,V,t),o(e,Qe,t),u(q,e,t),o(e,Xe,t),o(e,j,t),o(e,et,t),o(e,B,t),o(e,tt,t),o(e,N,t),o(e,it,t),o(e,E,t),o(e,ot,t),u(D,e,t),o(e,lt,t),o(e,K,t),o(e,at,t),o(e,G,t),o(e,nt,t),o(e,F,t),o(e,rt,t),o(e,g,t),o(e,st,t),o(e,J,t),o(e,ht,t),u(O,e,t),o(e,mt,t),o(e,Y,t),o(e,ut,t),u(Z,e,t),o(e,ft,t),o(e,Q,t),o(e,pt,t),o(e,X,t),o(e,ct,t),u(ee,e,t),o(e,dt,t),o(e,te,t),o(e,gt,t),o(e,ie,t),o(e,vt,t),o(e,oe,t),o(e,wt,t),o(e,le,t),o(e,yt,t),o(e,ae,t),o(e,bt,t),o(e,ne,t),o(e,Ct,t),o(e,re,t),o(e,xt,t),o(e,se,t),o(e,Tt,t),o(e,he,t),o(e,Mt,t),o(e,me,t),o(e,Lt,t),o(e,ue,t),o(e,Ht,t),o(e,fe,t),o(e,$t,t),o(e,pe,t),o(e,kt,t),o(e,ce,t),o(e,_t,t),o(e,de,t),o(e,Pt,t),o(e,ge,t),o(e,St,t),o(e,ve,t),o(e,At,t),o(e,we,t),o(e,Ut,t),o(e,ye,t),o(e,zt,t),o(e,be,t),o(e,Rt,t),o(e,Ce,t),o(e,Wt,t),o(e,xe,t),o(e,It,t),o(e,Te,t),o(e,Vt,t),o(e,Me,t),o(e,qt,t),o(e,Le,t),o(e,jt,t),o(e,He,t),o(e,Bt,t),o(e,_e,t),Nt=!0},p:Gi,i(e){Nt||(f(w.$$.fragment,e),f(T.$$.fragment,e),f(H.$$.fragment,e),f(P.$$.fragment,e),f(U.$$.fragment,e),f(R.$$.fragment,e),f(q.$$.fragment,e),f(D.$$.fragment,e),f(O.$$.fragment,e),f(Z.$$.fragment,e),f(ee.$$.fragment,e),Nt=!0)},o(e){p(w.$$.fragment,e),p(T.$$.fragment,e),p(H.$$.fragment,e),p(P.$$.fragment,e),p(U.$$.fragment,e),p(R.$$.fragment,e),p(q.$$.fragment,e),p(D.$$.fragment,e),p(O.$$.fragment,e),p(Z.$$.fragment,e),p(ee.$$.fragment,e),Nt=!1},d(e){e&&(i(Pe),i(ke),i(Se),i(Ae),i(y),i(Ue),i(b),i(ze),i(C),i(Re),i(x),i(We),i(Ie),i(M),i(Ve),i(L),i(qe),i(je),i($),i(Be),i(k),i(Ne),i(_),i(Ee),i(De),i(S),i(Ke),i(A),i(Ge),i(Fe),i(z),i(Je),i(Oe),i(W),i(Ye),i(I),i(Ze),i(V),i(Qe),i(Xe),i(j),i(et),i(B),i(tt),i(N),i(it),i(E),i(ot),i(lt),i(K),i(at),i(G),i(nt),i(F),i(rt),i(g),i(st),i(J),i(ht),i(mt),i(Y),i(ut),i(ft),i(Q),i(pt),i(X),i(ct),i(dt),i(te),i(gt),i(ie),i(vt),i(oe),i(wt),i(le),i(yt),i(ae),i(bt),i(ne),i(Ct),i(re),i(xt),i(se),i(Tt),i(he),i(Mt),i(me),i(Lt),i(ue),i(Ht),i(fe),i($t),i(pe),i(kt),i(ce),i(_t),i(de),i(Pt),i(ge),i(St),i(ve),i(At),i(we),i(Ut),i(ye),i(zt),i(be),i(Rt),i(Ce),i(Wt),i(xe),i(It),i(Te),i(Vt),i(Me),i(qt),i(Le),i(jt),i(He),i(Bt),i(_e)),i(v),c(w,e),c(T,e),c(H,e),c(P,e),c(U,e),c(R,e),c(q,e),c(D,e),c(O,e),c(Z,e),c(ee,e)}}}const Xi='{"title":"Welcome to the Community Computer Vision Course","local":"welcome-to-the-community-computer-vision-course","sections":[{"title":"Assignment 📄","local":"assignment-","sections":[{"title":"Training/fine-tuning a Model","local":"trainingfine-tuning-a-model","sections":[],"depth":3},{"title":"Creating a Space","local":"creating-a-space","sections":[],"depth":3}],"depth":2},{"title":"Certification 🥇","local":"certification-","sections":[],"depth":2},{"title":"Join the community!","local":"join-the-community","sections":[],"depth":2},{"title":"Computer Vision Channels","local":"computer-vision-channels","sections":[],"depth":2},{"title":"What you will learn","local":"what-you-will-learn","sections":[],"depth":2},{"title":"Pre-requisites","local":"pre-requisites","sections":[],"depth":2},{"title":"Course Structure","local":"course-structure","sections":[],"depth":2},{"title":"Meet our team","local":"meet-our-team","sections":[],"depth":2}],"depth":1}';function eo(Dt){return Fi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class lo extends Ji{constructor(v){super(),Oi(this,v,eo,Qi,Di,{})}}export{lo as component};
