import{s as vt,n as gt,o as yt}from"../chunks/scheduler.7bc62968.js";import{S as $t,i as wt,g as o,s as a,r as m,A as xt,h as s,f as n,c as l,j as ct,u as h,x as r,k as dt,y as _t,a as i,v as f,d as u,t as c,w as d}from"../chunks/index.66556066.js";import{H as v}from"../chunks/Heading.3f0870db.js";function Ht(Oe){let p,te,Y,ne,g,ie,y,ae,$,Ee="Hyena is a new type of operator that serves as a substitute for the attention mechanism. Developed by Hazy Research, it features a subquadratic computational efficiency, constructed by interleaving implicitly parametrized long convolutions and data-controlled gating.",le,w,Re=`<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/transformer2hyena.png" alt="transformer2hyena.png"/>
It consists of recursively computing convolutions and multiplicative element-wise gating operations. This approach builds on top of the <a href="https://arxiv.org/abs/2212.14052" rel="nofollow">Hungry Hungry Hippo (H3)</a> mechanism, also developed by the same researchers. The H3 mechanism is characterized by its data-controlled, parametric decomposition, acting as a surrogate attention mechanism.`,oe,x,Be="Another way of understanding Hyena is to consider it as a generalization of the H3 mechanism for an arbitrary number of projections, where the Hyena layer extends recursively H3 with a different choice of parametrization for the long convolution.",se,_,re,H,Ue="The attention mechanism is characterized by two fundamental properties:",pe,b,We="<li>It possesses a global contextual awareness, enabling it to assess interactions between pairs of visual tokens within a sequence.</li> <li>It is data-dependent, meaning the operation of the attention equation varies based on the input data itself, specifically the input projections  $q$, $k$ and $v$.</li>",me,T,Ge="In an attempt to replicate these characteristics, the Hyena operator incorporates two key elements:",he,C,Ve="<li>It employs long convolution to provide a sense of global context, akin to the first property of the attention mechanism.</li> <li>For data dependency, Hyena uses element-wise gating. This is essentially an element-wise multiplication of input projections, mirroring the data-dependent nature of traditional attention.</li>",fe,L,Ze="In the realm of computational efficiency, the Hyena operator attains an evaluation time complexity of $O(L \\times \\log_2 L)$, indicating a noteworthy enhancement in processing speed.",ue,M,ce,k,Je=`Let’s delve into the second-order recursion of the Hyena operator, which simplifies its representation for illustrative purposes.
<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/hyena_mechanism.png" alt="hyena_mechanism.png"/>`,de,P,Ke="In this context, $x_1$ and $x_2$ are equivalent to $q$ and $v$ attention vectors from the Attention mechanism. However, unlike the attention mechanism, which typically uses a dense layer for projecting the input sequence into representations, Hyena incorporates both a dense layer and standard convolutions. Here, $k$ and $v$ are aggregated with an elementwise multiplication operation.",ve,z,Qe="The core idea is to repeatedly apply linear operators that are fast to evaluate to an input sequence $u \\in \\mathbb{R}^{L}$ with $L$ the length of the sequence. A notable design choice is the use of <strong>implicit convolutions</strong>. Unlike standard convolutional layers, the convolution filter $h$ is learned implicitly with a small neural network $\\gamma<em>{\\theta}$ (also called the Hyena Filter). This network takes the positional index and potentially positional encodings as inputs. From the outputs of $\\gamma</em>{\\theta}$ one can construct a Toeplitz matrix $T_{h}$. *This implies that instead of learning the values of the convolution filter directly, we learn a mapping from a temporal positional encoding to the values, which is more computationally efficient, especially for long sequences.",ge,q,Xe="NB : It’s important to note that the mapping function  $\\gamma_{\\theta}$  can be conceptualized within various abstract models, such Neural Field or State Space Models (S4) as discussed in H3 paper.",ye,F,$e,I,Ye='Convolutions can be transformed into matrix multiplication using a <a href="https://en.wikipedia.org/wiki/Toeplitz_matrix" rel="nofollow">Toeplitz matrix</a>.',we,S,et=`<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/toeplitz_conv.jpg" alt="toeplitz_conv.jpg"/>
This transformation leads to greater parameter efficiency. Instead of directly learning fixed kernel weight values, a parametrized function is employed. This function intelligently deduces the values of the kernel weights and their dimensions during the network’s forward pass, optimizing resource use.`,xe,j,tt="In practice, convolutions are accelerated to a subquadratic time complexity by the Cooley-Tukey fast Fourier transform (FFT) algorithm. Some work has been conducted to speed up this computation like FastFFTConv based on Monarch decomposition.",_e,A,He,D,nt=`<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/nd_hyena.png" alt="nd_hyena.png"/>
In essence, Hyena can be performed in two steps:
1) Compute a set of N+1 linear projections similarly of attention (it can be more than 3 projections)
2) Mixing up the projections : The matrix H(u) is defined by a combination of matrix multiplications`,be,N,Te,O,it="While Transformer is a well established and very capable architecture, the quadratic computational cost is an expensive price to pay, especially in inference. The H3 mechanism proposition went close to the perplexity of multi-headed attention mechanisms, but there was still a narrow gap in terms of perplexity.",Ce,E,at="A variety of attention replacements have been proposed over the last few years, and evaluating the quality of a new architecture during the exploratory phase remains challenging. Creating a versatile layer that can effectively process N-Dimensional data within deep neural networks while maintaining good expressiveness is a significant area of ongoing research.",Le,R,lt='Empirically, Hyena operators are able to significantly shrink the quality gap with attention at scale, reaching similar perplexity and downstream performance with a smaller computational budget and without hybridization of attention. It has already achieved a state-of-the-art status for <a href="https://arxiv.org/abs/2306.15794" rel="nofollow">DNA sequence modeling</a> and shows great promise in the field of large language models with Stripped-Hyena-7B.',Me,B,ot="Similarly to Attention, Hyena can be used in computer vision tasks. In image classification, Hyena is able to match attention in accuracy when training on ImageNet-1k from scratch.",ke,U,st=`<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/hyena_vision_benchmarks.png" alt="hyena_vision_benchmarks.png"/>
Hyena has been applied to N-Dimensional data with the Hyena N-D layer and can be used as direct drop-in replacement within the ViT, Swin, DeiT backbones.`,Pe,W,rt=`<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/outlook_hyena_images/vit_vs_hyenavit.png" alt="vit_vs_hyenavit.png"/>
here is a noticeable enhancement in GPU memory efficiency with the increase in the number of image patches.`,ze,G,pt="Hyena Hierarchy facilitates the development of larger, more efficient convolution models for long sequences. The potential for Hyena type models for computer vision would be a more efficient GPU memory consumption of patches, that would allow :",qe,V,mt="<li>The processing of larger, higher-resolution images</li> <li>The use ofwith smaller patches, allowing a fine-graine feature representation</li>",Fe,Z,Ie,J,ht="Building new layers from simple design principles is an emerging research field that is progressing very quickly.",Se,K,ft="The H3 mechanism serves as the foundation for many State Space Model based (SSM) architectures, typically featuring a structure that alternates between a block inspired by linear attention and a multi-layer perceptron (MLP) block. Hyena, as an enhancement of this approach, has paved the way for even more efficient architectures such as Mamba.",je,Q,Ae,X,ut='<li>On the landscape of subquadratic models: <a href="https://hazyresearch.stanford.edu/blog/2023-06-08-hyena-safari" rel="nofollow">The Safari of Deep Signal Processing: Hyena and Beyond · Hazy Research (stanford.edu)</a></li> <li>On speeding up the FFT algorithm: <a href="https://hazyresearch.stanford.edu/blog/2023-11-13-flashfftconv" rel="nofollow">FlashFFTConv: Efficient Convolutions for Long Sequences with Tensor Cores · Hazy Research (stanford.edu)</a></li> <li>On the subquadratic model landscape: <a href="https://hazyresearch.stanford.edu/blog/2023-12-11-zoology1-analysis" rel="nofollow">Zoology (Blogpost 1): Measuring and Improving Recall in Efficient Language Models · Hazy Research (stanford.edu)</a></li> <li>Hyena applied to computer vision: <a href="https://arxiv.org/abs/2309.13600" rel="nofollow">[2309.13600] Multi-Dimensional Hyena for Spatial Inductive Bias (arxiv.org)</a></li>',De,ee,Ne;return g=new v({props:{title:"Overview",local:"overview",headingTag:"h2"}}),y=new v({props:{title:"What is Hyena",local:"what-is-hyena",headingTag:"h3"}}),_=new v({props:{title:"From Attention to Hyena operator",local:"from-attention-to-hyena-operator",headingTag:"h3"}}),M=new v({props:{title:"Hyena operator",local:"hyena-operator",headingTag:"h3"}}),F=new v({props:{title:"Implicit convolutions",local:"implicit-convolutions",headingTag:"h3"}}),A=new v({props:{title:"Wrapping up everything",local:"wrapping-up-everything",headingTag:"h3"}}),N=new v({props:{title:"Why it matters",local:"why-it-matters",headingTag:"h2"}}),Z=new v({props:{title:"Toward Transformers Alternatives",local:"toward-transformers-alternatives",headingTag:"h2"}}),Q=new v({props:{title:"Further reading",local:"further-reading",headingTag:"h2"}}),{c(){p=o("meta"),te=a(),Y=o("p"),ne=a(),m(g.$$.fragment),ie=a(),m(y.$$.fragment),ae=a(),$=o("p"),$.textContent=Ee,le=a(),w=o("p"),w.innerHTML=Re,oe=a(),x=o("p"),x.textContent=Be,se=a(),m(_.$$.fragment),re=a(),H=o("p"),H.textContent=Ue,pe=a(),b=o("ol"),b.innerHTML=We,me=a(),T=o("p"),T.textContent=Ge,he=a(),C=o("ol"),C.innerHTML=Ve,fe=a(),L=o("p"),L.textContent=Ze,ue=a(),m(M.$$.fragment),ce=a(),k=o("p"),k.innerHTML=Je,de=a(),P=o("p"),P.textContent=Ke,ve=a(),z=o("p"),z.innerHTML=Qe,ge=a(),q=o("p"),q.textContent=Xe,ye=a(),m(F.$$.fragment),$e=a(),I=o("p"),I.innerHTML=Ye,we=a(),S=o("p"),S.innerHTML=et,xe=a(),j=o("p"),j.textContent=tt,_e=a(),m(A.$$.fragment),He=a(),D=o("p"),D.innerHTML=nt,be=a(),m(N.$$.fragment),Te=a(),O=o("p"),O.textContent=it,Ce=a(),E=o("p"),E.textContent=at,Le=a(),R=o("p"),R.innerHTML=lt,Me=a(),B=o("p"),B.textContent=ot,ke=a(),U=o("p"),U.innerHTML=st,Pe=a(),W=o("p"),W.innerHTML=rt,ze=a(),G=o("p"),G.textContent=pt,qe=a(),V=o("ul"),V.innerHTML=mt,Fe=a(),m(Z.$$.fragment),Ie=a(),J=o("p"),J.textContent=ht,Se=a(),K=o("p"),K.textContent=ft,je=a(),m(Q.$$.fragment),Ae=a(),X=o("ul"),X.innerHTML=ut,De=a(),ee=o("p"),this.h()},l(e){const t=xt("svelte-u9bgzb",document.head);p=s(t,"META",{name:!0,content:!0}),t.forEach(n),te=l(e),Y=s(e,"P",{}),ct(Y).forEach(n),ne=l(e),h(g.$$.fragment,e),ie=l(e),h(y.$$.fragment,e),ae=l(e),$=s(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1cq9qzc"&&($.textContent=Ee),le=l(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1mbkzfu"&&(w.innerHTML=Re),oe=l(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-15g4zf5"&&(x.textContent=Be),se=l(e),h(_.$$.fragment,e),re=l(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1nqx0mq"&&(H.textContent=Ue),pe=l(e),b=s(e,"OL",{"data-svelte-h":!0}),r(b)!=="svelte-1wtwggr"&&(b.innerHTML=We),me=l(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-ip342p"&&(T.textContent=Ge),he=l(e),C=s(e,"OL",{"data-svelte-h":!0}),r(C)!=="svelte-x7l1j4"&&(C.innerHTML=Ve),fe=l(e),L=s(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1m3dxzu"&&(L.textContent=Ze),ue=l(e),h(M.$$.fragment,e),ce=l(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1e3lueh"&&(k.innerHTML=Je),de=l(e),P=s(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1eky1m8"&&(P.textContent=Ke),ve=l(e),z=s(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-15e51u8"&&(z.innerHTML=Qe),ge=l(e),q=s(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-bx5uf"&&(q.textContent=Xe),ye=l(e),h(F.$$.fragment,e),$e=l(e),I=s(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1u2rza8"&&(I.innerHTML=Ye),we=l(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1segswi"&&(S.innerHTML=et),xe=l(e),j=s(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-nma9mj"&&(j.textContent=tt),_e=l(e),h(A.$$.fragment,e),He=l(e),D=s(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-m50cuc"&&(D.innerHTML=nt),be=l(e),h(N.$$.fragment,e),Te=l(e),O=s(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-92ptgm"&&(O.textContent=it),Ce=l(e),E=s(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1mwzhv4"&&(E.textContent=at),Le=l(e),R=s(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-hcl31m"&&(R.innerHTML=lt),Me=l(e),B=s(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-as36q9"&&(B.textContent=ot),ke=l(e),U=s(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-9amuno"&&(U.innerHTML=st),Pe=l(e),W=s(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-9eeax6"&&(W.innerHTML=rt),ze=l(e),G=s(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1dgar90"&&(G.textContent=pt),qe=l(e),V=s(e,"UL",{"data-svelte-h":!0}),r(V)!=="svelte-m4pngb"&&(V.innerHTML=mt),Fe=l(e),h(Z.$$.fragment,e),Ie=l(e),J=s(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-10si01d"&&(J.textContent=ht),Se=l(e),K=s(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-10vx0w7"&&(K.textContent=ft),je=l(e),h(Q.$$.fragment,e),Ae=l(e),X=s(e,"UL",{"data-svelte-h":!0}),r(X)!=="svelte-n7m5hw"&&(X.innerHTML=ut),De=l(e),ee=s(e,"P",{}),ct(ee).forEach(n),this.h()},h(){dt(p,"name","hf:doc:metadata"),dt(p,"content",bt)},m(e,t){_t(document.head,p),i(e,te,t),i(e,Y,t),i(e,ne,t),f(g,e,t),i(e,ie,t),f(y,e,t),i(e,ae,t),i(e,$,t),i(e,le,t),i(e,w,t),i(e,oe,t),i(e,x,t),i(e,se,t),f(_,e,t),i(e,re,t),i(e,H,t),i(e,pe,t),i(e,b,t),i(e,me,t),i(e,T,t),i(e,he,t),i(e,C,t),i(e,fe,t),i(e,L,t),i(e,ue,t),f(M,e,t),i(e,ce,t),i(e,k,t),i(e,de,t),i(e,P,t),i(e,ve,t),i(e,z,t),i(e,ge,t),i(e,q,t),i(e,ye,t),f(F,e,t),i(e,$e,t),i(e,I,t),i(e,we,t),i(e,S,t),i(e,xe,t),i(e,j,t),i(e,_e,t),f(A,e,t),i(e,He,t),i(e,D,t),i(e,be,t),f(N,e,t),i(e,Te,t),i(e,O,t),i(e,Ce,t),i(e,E,t),i(e,Le,t),i(e,R,t),i(e,Me,t),i(e,B,t),i(e,ke,t),i(e,U,t),i(e,Pe,t),i(e,W,t),i(e,ze,t),i(e,G,t),i(e,qe,t),i(e,V,t),i(e,Fe,t),f(Z,e,t),i(e,Ie,t),i(e,J,t),i(e,Se,t),i(e,K,t),i(e,je,t),f(Q,e,t),i(e,Ae,t),i(e,X,t),i(e,De,t),i(e,ee,t),Ne=!0},p:gt,i(e){Ne||(u(g.$$.fragment,e),u(y.$$.fragment,e),u(_.$$.fragment,e),u(M.$$.fragment,e),u(F.$$.fragment,e),u(A.$$.fragment,e),u(N.$$.fragment,e),u(Z.$$.fragment,e),u(Q.$$.fragment,e),Ne=!0)},o(e){c(g.$$.fragment,e),c(y.$$.fragment,e),c(_.$$.fragment,e),c(M.$$.fragment,e),c(F.$$.fragment,e),c(A.$$.fragment,e),c(N.$$.fragment,e),c(Z.$$.fragment,e),c(Q.$$.fragment,e),Ne=!1},d(e){e&&(n(te),n(Y),n(ne),n(ie),n(ae),n($),n(le),n(w),n(oe),n(x),n(se),n(re),n(H),n(pe),n(b),n(me),n(T),n(he),n(C),n(fe),n(L),n(ue),n(ce),n(k),n(de),n(P),n(ve),n(z),n(ge),n(q),n(ye),n($e),n(I),n(we),n(S),n(xe),n(j),n(_e),n(He),n(D),n(be),n(Te),n(O),n(Ce),n(E),n(Le),n(R),n(Me),n(B),n(ke),n(U),n(Pe),n(W),n(ze),n(G),n(qe),n(V),n(Fe),n(Ie),n(J),n(Se),n(K),n(je),n(Ae),n(X),n(De),n(ee)),n(p),d(g,e),d(y,e),d(_,e),d(M,e),d(F,e),d(A,e),d(N,e),d(Z,e),d(Q,e)}}}const bt='{"title":"Overview","local":"overview","sections":[{"title":"What is Hyena","local":"what-is-hyena","sections":[],"depth":3},{"title":"From Attention to Hyena operator","local":"from-attention-to-hyena-operator","sections":[],"depth":3},{"title":"Hyena operator","local":"hyena-operator","sections":[],"depth":3},{"title":"Implicit convolutions","local":"implicit-convolutions","sections":[],"depth":3},{"title":"Wrapping up everything","local":"wrapping-up-everything","sections":[],"depth":3}],"depth":2}';function Tt(Oe){return yt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class kt extends $t{constructor(p){super(),wt(this,p,Tt,Ht,vt,{})}}export{kt as component};
