import{s as $t,n as Ht,o as _t}from"../chunks/scheduler.7bc62968.js";import{S as kt,i as Pt,g as l,s as a,r as m,A as Vt,h as o,f as i,c as s,j as Ct,u as g,x as r,k as Tt,y as It,a as n,v as u,d as p,t as h,w as f}from"../chunks/index.66556066.js";import{H as c}from"../chunks/Heading.3f0870db.js";function zt(Re){let d,ae,ie,se,v,le,w,Be="What will you learn from this chapter:",oe,b,Ke="<li>A brief introduction to multimodality</li> <li>Introduction to Vision Language Models</li> <li>Various learning strategies</li> <li>Common datasets used for VLMs</li> <li>Downstream tasks and evaluation</li>",re,x,de,y,Ze=`Humans explore the world through diverse senses: sight, sound, touch, and scent. A complete grasp of our surroundings emerges by harmonizing insights from these varied modalities.
We think of modality, initially introduced in mathematics as distinct peaks, in a poetic way as: “With each modality, a unique part to play, Together they form our understanding array. A symphony of senses, a harmonious blend, In perception’s dance, our world transcends.” In pursuit of making a AI capable to understand the world, the field of machine learning seeks to develop models capable of processing and integrating data across multiple modalities. However, several challenges, including representation and alignment, must be addressed. Representation explores techniques to effectively summarize multimodal data, capturing the intricate connections among individual modality elements. Alignment focuses on identifying connections and interactions across all elements.
Also, it is crucial to acknowledge the inherent difficulties in handling multimodality:`,me,L,Je="<li>One modality may dominate others.</li> <li>Additional modalities can introduce noise.</li> <li>Full coverage over all modalities is not guaranteed.</li> <li>Different modalities can have complicated relationships.</li>",ge,M,Qe="Despite these challenges, the machine learning community has significantly progressed in developing these systems. This chapter delves into the fusion of vision and language, giving rise to Vision Language Models (VLMs). For a deeper understanding of multimodality, please refer to the preceding section of this Unit.",ue,C,pe,T,Xe="Processing images to generate text, such as image captioning and visual question-answering, has been studied for many years which includes autonomous driving, remote sensing, etc. We also have seen a shift from traditional ML/DL training from scratch to a new learning paradigm including pre-training, fine-tuning and prediction, which has shown great benefit since in the traditional way we may need to collect huge amount of data, etc.",he,$,Ye='Firstly proposed in <a href="https://aclanthology.org/P18-1031.pdf" rel="nofollow">ULMFIT Paper</a> this paradigm involves:',fe,H,et="<li>Pre-training the model with extensive training data.</li> <li>Fine-tuning the pre-trained model with task-specific data.</li> <li>Utilizing the trained model for downstream tasks such as classification.</li>",ce,_,tt='In VLMs, we employ this paradigm and extend it to combine visual images, yielding the desired results. For instance, in 2021, OpenAI introduced a groundbreaking paper called <a href="https://openai.com/research/clip" rel="nofollow">CLIP</a> which significantly influenced the adoption of this approach. CLIP utilizes an image-text contrastive objective, learning by bringing paired images and texts close while pushing others far away in the embedding space. This pre-training method allows VLMs to capture rich vision-language correspondence knowledge, enabling zero-shot predictions by matching the embeddings of any given images and texts. Notably, CLIP outperformed Imagenet models on out-of-distribution tasks. Further exploration of CLIP and similar models is covered in the next section of this chapter!',ve,k,we,P,it="To enable the functionality of Vision Language Models (VLMs), a meaningful combination of both text and images is essential for joint learning. How can we do that? One simple/common way is given image-text pairs:",be,V,nt="<li>Extract image and text features using text and image encoders. For images it can be <strong>CNN</strong> or <strong>transformer</strong> based architectures.</li> <li>Learn the vision-language correlation with certain pre-training objectives.<ul><li>The pre-training objective can be divided into three groups:<ul><li><strong>contrastive</strong> objectives train VLMs to learn discriminative representations by pulling paired samples close and pushing others faraway in the embedding space.</li> <li><strong>generative</strong> objectives to make VLMs learn semantic features by training networks to generate image/text data.</li> <li><strong>alignment</strong> objectives align the image-text pair via global image-text matching or local region-word matching on embedding space.</li></ul></li></ul></li> <li>With the learned vision-language correlation, VLMs can be evaluated on unseen data in a zero-shot manner by matching the embeddings of any given images and texts.</li>",xe,I,at='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/99ac107ade7fb89aae792f3655341528e64e1fbb/clip_paper.png" alt="Basic Mechanism of CLIP model"/>',ye,z,st="Existing research predominantly focuses on enhancing VLMs from three key perspectives:",Le,j,lt="<li>collecting large-scale informative image-text data.</li> <li>designing effective models for learning from big data.</li> <li>designing new pre-training methods/objective for learning effective vision-language correlation.</li>",Me,F,ot="VLM pre-training aims to pre-train a VLM to learn image-text correlation, targeting effective zero-shot predictions on visual recognition tasks which can be segmentation, classification, etc.",Ce,O,Te,A,rt='We can <a href="https://lilianweng.github.io/posts/2022-06-09-vlm/#no-training" rel="nofollow">group</a> VLMs based on how we leverage the two modes of learning.',$e,q,dt='<li><p>Translating images into embedding features that can be jointly trained with token embeddings.</p> <ul><li>In this method we fuse visual information into language models by treating images as normal text tokens and train the model on a sequence of joint representations of both text and images. Precisely, images are divided into multiple smaller patches and each patch is treated as one “token” in the input sequence. e.g. <a href="https://arxiv.org/abs/1908.03557" rel="nofollow">VisualBERT</a>, <a href="https://arxiv.org/abs/2108.10904" rel="nofollow">SimVLM</a>.</li></ul></li> <li><p>Learning good image embeddings that can work as a prefix for a frozen, pre-trained language model.</p> <ul><li>In this method we don’t change the language model parameters when adapting to handle visual signals. Instead we learn such an embedding space for images, such that it is compatible with the language model’s. e.g. <a href="https://arxiv.org/abs/2106.13884" rel="nofollow">Frozen</a>, <a href="https://arxiv.org/abs/2111.09734" rel="nofollow">ClipCap</a>.</li></ul></li> <li><p>Using a specially designed cross-attention mechanism to fuse visual information into layers of the language model.</p> <ul><li>For enhanced fusion of visual information across language model layers, employ a tailored cross-attention fuse mechanism to balance text generation and visual input. Eg. <a href="https://arxiv.org/abs/2102.10407" rel="nofollow">VisualGPT</a>, etc.</li></ul></li> <li><p>Combine vision and language models without any training.</p> <ul><li>More recent methods like <a href="https://arxiv.org/abs/2205.02655" rel="nofollow">MAGiC</a> does guided decoding to sample next token, without fine-tuning.</li></ul></li>',He,W,_e,S,mt='These are some of the common dataset used in VLM’s present in <a href="https://huggingface.co/docs/datasets/index" rel="nofollow">HF dataset</a>.',ke,D,gt='<strong><a href="https://huggingface.co/datasets/HuggingFaceM4/COCO" rel="nofollow">MSCOCO</a></strong> contains 328K images and each paired with 5 independent captions.',Pe,E,ut='<strong><a href="https://huggingface.co/datasets/HuggingFaceM4/NoCaps" rel="nofollow">NoCaps</a></strong> designed to measure generalization to unseen classes and concepts, where in-domain contains images portraying only COCO classes, near-domain contains both COCO and novel classes, and out-of-domain consists of only novel classes.',Ve,U,pt='<strong><a href="https://huggingface.co/datasets/conceptual_captions" rel="nofollow">Conceptual Captions</a></strong> contains 3 million pairs of images and captions, mined from the web and post-processed.',Ie,N,ht='<strong><a href="https://huggingface.co/blog/vit-align" rel="nofollow">ALIGN</a></strong>  a noisy dataset of over one billion image alt-text pairs, obtained without expensive filtering or post-processing steps in the Conceptual Captions dataset.',ze,G,ft='<strong><a href="https://huggingface.co/collections/laion/openclip-datacomp-64fcac9eb961d0d12cb30bc3" rel="nofollow">LAION</a></strong> dataset consists of image-text-pairs. The image-text-pairs have been extracted from the Common Crawl web data dump and are from random web pages crawled between 2014 and 2021. This dataset was used in training Stable-Diffusion Models.',je,R,Fe,B,ct="VLMs are getting good at many downstream tasks, including image classification, object detection, semantic segmentation, image-text retrieval, and action recognition while surpassing models trained traditionally.",Oe,K,vt="Generally the setup used for evaluating VLMs is zero-shot prediction and linear probing. Zero-shot prediction is the most common way to evaluate the VLMs, where we directly apply pre-trained VLMs to downstream tasks without any task-specific fine-tuning.",Ae,Z,wt='In linear probing, we freeze the pre-trained VLM and train a linear classifier to classify the VLM-encoded embeddings to measure its representation. How do we evaluate these models? We can check how they perform on datasets, e.g. given an image and a question, the task is to answer the question correctly! We can also check how these models reason answer questions about the visual data. For this, the most common dataset used is <a href="https://cs.stanford.edu/people/jcjohns/clevr/" rel="nofollow">CLEVR</a>.',qe,J,bt='Standard datasets like MSCOCO might be straightforward for a model to learn due to their distribution, which may not adequately demonstrate a model’s capacity to generalize across more challenging or diverse datasets. In response, datasets like <a href="https://arxiv.org/abs/2005.04790" rel="nofollow">Hateful Memes</a> are created to address this problem by understanding the models capability to an extreme by adding difficult examples (“benign confounders”) to the dataset to make it hard which showed that multimodal pre-training doesn’t work and models had a huge gap with human performance.',We,Q,xt='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/99ac107ade7fb89aae792f3655341528e64e1fbb/winogrand_paper.png" alt="Winogrand Idea"/>',Se,X,yt="One more such dataset called <strong>Winoground</strong> was designed to figure out how good CLIP actually is. <strong>Figure Above</strong> This dataset challenges us to consider if models, despite their impressive results, truly grasp compositional relationships like humans or if they’re generalizing data. For example, earlier versions of Stable Diffusion and other text-to-image models, were not able to clearly count fingers. So, there’s still lot of amazing work to be done to get the VLM’s to the next stage!",De,Y,Ee,ee,Lt='The community is moving fast and we can see already lot of amazing work like <a href="https://arxiv.org/abs/2112.04482" rel="nofollow">FLAVA</a> which tries to have a single “foundational” model for all the target modalities at once. This is one possible scenario for the future - modality-agnostic foundation models that can read and generate many modalities! But maybe we also see other alternatives developing, one thing we can say for sure is . there is an interesting future ahead.',Ue,te,Mt='To capture more on these recent advances feel free follow the HF’s <a href="https://huggingface.co/docs/transformers/index" rel="nofollow">Transformers Library</a>, and <a href="https://huggingface.co/docs/diffusers/index" rel="nofollow">Diffusers Library</a> where we try to add recent advances and models as fast as possible! If you feel like we are missing something important, you can also open an issue for these libraries and contribute code yourself.',Ne,ne,Ge;return v=new c({props:{title:"Introduction to Vision Language Models",local:"introduction-to-vision-language-models",headingTag:"h1"}}),x=new c({props:{title:"Our World is Multimodal",local:"our-world-is-multimodal",headingTag:"h2"}}),C=new c({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),k=new c({props:{title:"Mechanism",local:"mechanism",headingTag:"h2"}}),O=new c({props:{title:"Strategies",local:"strategies",headingTag:"h2"}}),W=new c({props:{title:"Common VLM Datasets",local:"common-vlm-datasets",headingTag:"h2"}}),R=new c({props:{title:"Downstream Tasks and Evaluation",local:"downstream-tasks-and-evaluation",headingTag:"h2"}}),Y=new c({props:{title:"What’s Next?",local:"whats-next",headingTag:"h2"}}),{c(){d=l("meta"),ae=a(),ie=l("p"),se=a(),m(v.$$.fragment),le=a(),w=l("p"),w.textContent=Be,oe=a(),b=l("ul"),b.innerHTML=Ke,re=a(),m(x.$$.fragment),de=a(),y=l("p"),y.textContent=Ze,me=a(),L=l("ul"),L.innerHTML=Je,ge=a(),M=l("p"),M.textContent=Qe,ue=a(),m(C.$$.fragment),pe=a(),T=l("p"),T.textContent=Xe,he=a(),$=l("p"),$.innerHTML=Ye,fe=a(),H=l("ul"),H.innerHTML=et,ce=a(),_=l("p"),_.innerHTML=tt,ve=a(),m(k.$$.fragment),we=a(),P=l("p"),P.textContent=it,be=a(),V=l("ul"),V.innerHTML=nt,xe=a(),I=l("p"),I.innerHTML=at,ye=a(),z=l("p"),z.textContent=st,Le=a(),j=l("ul"),j.innerHTML=lt,Me=a(),F=l("p"),F.textContent=ot,Ce=a(),m(O.$$.fragment),Te=a(),A=l("p"),A.innerHTML=rt,$e=a(),q=l("ul"),q.innerHTML=dt,He=a(),m(W.$$.fragment),_e=a(),S=l("p"),S.innerHTML=mt,ke=a(),D=l("p"),D.innerHTML=gt,Pe=a(),E=l("p"),E.innerHTML=ut,Ve=a(),U=l("p"),U.innerHTML=pt,Ie=a(),N=l("p"),N.innerHTML=ht,ze=a(),G=l("p"),G.innerHTML=ft,je=a(),m(R.$$.fragment),Fe=a(),B=l("p"),B.textContent=ct,Oe=a(),K=l("p"),K.textContent=vt,Ae=a(),Z=l("p"),Z.innerHTML=wt,qe=a(),J=l("p"),J.innerHTML=bt,We=a(),Q=l("p"),Q.innerHTML=xt,Se=a(),X=l("p"),X.innerHTML=yt,De=a(),m(Y.$$.fragment),Ee=a(),ee=l("p"),ee.innerHTML=Lt,Ue=a(),te=l("p"),te.innerHTML=Mt,Ne=a(),ne=l("p"),this.h()},l(e){const t=Vt("svelte-u9bgzb",document.head);d=o(t,"META",{name:!0,content:!0}),t.forEach(i),ae=s(e),ie=o(e,"P",{}),Ct(ie).forEach(i),se=s(e),g(v.$$.fragment,e),le=s(e),w=o(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-146wklc"&&(w.textContent=Be),oe=s(e),b=o(e,"UL",{"data-svelte-h":!0}),r(b)!=="svelte-hdmp1n"&&(b.innerHTML=Ke),re=s(e),g(x.$$.fragment,e),de=s(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-k6b6a8"&&(y.textContent=Ze),me=s(e),L=o(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-idphev"&&(L.innerHTML=Je),ge=s(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-luunz8"&&(M.textContent=Qe),ue=s(e),g(C.$$.fragment,e),pe=s(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-ho6mvy"&&(T.textContent=Xe),he=s(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-82rv4t"&&($.innerHTML=Ye),fe=s(e),H=o(e,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-1cxsw03"&&(H.innerHTML=et),ce=s(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-58kv20"&&(_.innerHTML=tt),ve=s(e),g(k.$$.fragment,e),we=s(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1mvpmdi"&&(P.textContent=it),be=s(e),V=o(e,"UL",{"data-svelte-h":!0}),r(V)!=="svelte-tmrqi8"&&(V.innerHTML=nt),xe=s(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1jcr4r5"&&(I.innerHTML=at),ye=s(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1l367bq"&&(z.textContent=st),Le=s(e),j=o(e,"UL",{"data-svelte-h":!0}),r(j)!=="svelte-j6lhxf"&&(j.innerHTML=lt),Me=s(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-vjuh39"&&(F.textContent=ot),Ce=s(e),g(O.$$.fragment,e),Te=s(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1nawv71"&&(A.innerHTML=rt),$e=s(e),q=o(e,"UL",{"data-svelte-h":!0}),r(q)!=="svelte-1keccdn"&&(q.innerHTML=dt),He=s(e),g(W.$$.fragment,e),_e=s(e),S=o(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1d7zmjq"&&(S.innerHTML=mt),ke=s(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-11cbkvc"&&(D.innerHTML=gt),Pe=s(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-10t0byb"&&(E.innerHTML=ut),Ve=s(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-2xc3z"&&(U.innerHTML=pt),Ie=s(e),N=o(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-7e0l7l"&&(N.innerHTML=ht),ze=s(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-67p3dg"&&(G.innerHTML=ft),je=s(e),g(R.$$.fragment,e),Fe=s(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-e4kqvx"&&(B.textContent=ct),Oe=s(e),K=o(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1raz66s"&&(K.textContent=vt),Ae=s(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-1k1yb12"&&(Z.innerHTML=wt),qe=s(e),J=o(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-d35vqi"&&(J.innerHTML=bt),We=s(e),Q=o(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-shhrmb"&&(Q.innerHTML=xt),Se=s(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-3uzv9e"&&(X.innerHTML=yt),De=s(e),g(Y.$$.fragment,e),Ee=s(e),ee=o(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-19fuww6"&&(ee.innerHTML=Lt),Ue=s(e),te=o(e,"P",{"data-svelte-h":!0}),r(te)!=="svelte-1uni9s8"&&(te.innerHTML=Mt),Ne=s(e),ne=o(e,"P",{}),Ct(ne).forEach(i),this.h()},h(){Tt(d,"name","hf:doc:metadata"),Tt(d,"content",jt)},m(e,t){It(document.head,d),n(e,ae,t),n(e,ie,t),n(e,se,t),u(v,e,t),n(e,le,t),n(e,w,t),n(e,oe,t),n(e,b,t),n(e,re,t),u(x,e,t),n(e,de,t),n(e,y,t),n(e,me,t),n(e,L,t),n(e,ge,t),n(e,M,t),n(e,ue,t),u(C,e,t),n(e,pe,t),n(e,T,t),n(e,he,t),n(e,$,t),n(e,fe,t),n(e,H,t),n(e,ce,t),n(e,_,t),n(e,ve,t),u(k,e,t),n(e,we,t),n(e,P,t),n(e,be,t),n(e,V,t),n(e,xe,t),n(e,I,t),n(e,ye,t),n(e,z,t),n(e,Le,t),n(e,j,t),n(e,Me,t),n(e,F,t),n(e,Ce,t),u(O,e,t),n(e,Te,t),n(e,A,t),n(e,$e,t),n(e,q,t),n(e,He,t),u(W,e,t),n(e,_e,t),n(e,S,t),n(e,ke,t),n(e,D,t),n(e,Pe,t),n(e,E,t),n(e,Ve,t),n(e,U,t),n(e,Ie,t),n(e,N,t),n(e,ze,t),n(e,G,t),n(e,je,t),u(R,e,t),n(e,Fe,t),n(e,B,t),n(e,Oe,t),n(e,K,t),n(e,Ae,t),n(e,Z,t),n(e,qe,t),n(e,J,t),n(e,We,t),n(e,Q,t),n(e,Se,t),n(e,X,t),n(e,De,t),u(Y,e,t),n(e,Ee,t),n(e,ee,t),n(e,Ue,t),n(e,te,t),n(e,Ne,t),n(e,ne,t),Ge=!0},p:Ht,i(e){Ge||(p(v.$$.fragment,e),p(x.$$.fragment,e),p(C.$$.fragment,e),p(k.$$.fragment,e),p(O.$$.fragment,e),p(W.$$.fragment,e),p(R.$$.fragment,e),p(Y.$$.fragment,e),Ge=!0)},o(e){h(v.$$.fragment,e),h(x.$$.fragment,e),h(C.$$.fragment,e),h(k.$$.fragment,e),h(O.$$.fragment,e),h(W.$$.fragment,e),h(R.$$.fragment,e),h(Y.$$.fragment,e),Ge=!1},d(e){e&&(i(ae),i(ie),i(se),i(le),i(w),i(oe),i(b),i(re),i(de),i(y),i(me),i(L),i(ge),i(M),i(ue),i(pe),i(T),i(he),i($),i(fe),i(H),i(ce),i(_),i(ve),i(we),i(P),i(be),i(V),i(xe),i(I),i(ye),i(z),i(Le),i(j),i(Me),i(F),i(Ce),i(Te),i(A),i($e),i(q),i(He),i(_e),i(S),i(ke),i(D),i(Pe),i(E),i(Ve),i(U),i(Ie),i(N),i(ze),i(G),i(je),i(Fe),i(B),i(Oe),i(K),i(Ae),i(Z),i(qe),i(J),i(We),i(Q),i(Se),i(X),i(De),i(Ee),i(ee),i(Ue),i(te),i(Ne),i(ne)),i(d),f(v,e),f(x,e),f(C,e),f(k,e),f(O,e),f(W,e),f(R,e),f(Y,e)}}}const jt='{"title":"Introduction to Vision Language Models","local":"introduction-to-vision-language-models","sections":[{"title":"Our World is Multimodal","local":"our-world-is-multimodal","sections":[],"depth":2},{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Mechanism","local":"mechanism","sections":[],"depth":2},{"title":"Strategies","local":"strategies","sections":[],"depth":2},{"title":"Common VLM Datasets","local":"common-vlm-datasets","sections":[],"depth":2},{"title":"Downstream Tasks and Evaluation","local":"downstream-tasks-and-evaluation","sections":[],"depth":2},{"title":"What’s Next?","local":"whats-next","sections":[],"depth":2}],"depth":1}';function Ft(Re){return _t(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wt extends kt{constructor(d){super(),Pt(this,d,Ft,zt,$t,{})}}export{Wt as component};
